%{!?upstream_version: %global upstream_version %{version}%{?milestone}}
%global with_doc %{!?_without_doc:1}%{?_without_doc:0}

%global service sahara-tests
Name:           openstack-%{service}
Version:        0.4.1
Release:        1%{?dist}
Summary:        Sahara Scenario Test Framework
License:        ASL 2.0
URL:            http://launchpad.net/%{service}/

Source0:        https://tarballs.openstack.org/%{service}/%{service}-%{upstream_version}.tar.gz

#
# patches_ignore=DROP-IN-RPM
# patches_base=0.4.1
#

BuildArch:      noarch

BuildRequires:  git
BuildRequires:  python2-devel
BuildRequires:  python-pbr
BuildRequires:  python-setuptools

Requires:       python-pbr
Requires:       python-setuptools
Requires:       python-mako
Requires:       python-fixtures
Requires:       python-jsonschema
Requires:       python-oslo-concurrency
Requires:       python-oslo-serialization
Requires:       python-oslo-utils
Requires:       python-oslotest
Requires:       python-os-testr
Requires:       python-paramiko
Requires:       python-keystoneauth1
Requires:       python-glanceclient
Requires:       python-novaclient
Requires:       python-saharaclient
Requires:       python-swiftclient
Requires:       python-neutronclient
Requires:       python-rfc3986
Requires:       python-six
Requires:       python-tempest
Requires:       python-testrepository
Requires:       python-testtools

# test dependencies requirements
BuildRequires:    python-mock
BuildRequires:    python-coverage

%description
This project contains Sahara-scenario test framework.

%package -n python-%{service}-tempest
Summary:        OpenStack Sahara tempest plugin

Requires:       openstack-%{service} = %{version}-%{release}

%description -n python-%{service}-tempest
This project contains OpenStack Sahara tests tempest plugin

%package -n python-%{service}-scenario
Summary:        OpenStack Sahara test scenario plugin

Requires:       openstack-%{service} = %{version}-%{release}
Requires:       python-os-client-config

%description -n python-%{service}-scenario
This project contains OpenStack Sahara tests scenario plugin

%if 0%{?with_doc}
%package doc
Summary:          Documentation for OpenStack Sahara Tests

BuildRequires:    python-sphinx
BuildRequires:    python-oslo-sphinx
BuildRequires:    python-reno
%description      doc
This package contains the openstack sahara-tests Documentation files.
%endif

%prep
%autosetup -n %{service}-%{upstream_version} -S git

# Let RPM handle the dependencies
rm -rf {test-,}requirements.txt

%build
%{__python2} setup.py build

# docs generation
%if 0%{?with_doc}
%{__python2} setup.py build_sphinx
# Fix hidden-file-or-dir warnings
rm -fr doc/build/html/.doctrees doc/build/html/.buildinfo
# Remove zero-length files
find doc/build/html -size 0 -delete
%endif

%install
%{__python2} setup.py install -O1 --skip-build --root %{buildroot}

chmod +x %{buildroot}/%{python2_sitelib}/sahara_tests/scenario/runner.py
chmod +x %{buildroot}/%{python2_sitelib}/sahara_tests/scenario/defaults/edp-examples/edp-shell/shell-example.sh

install -d -m 755 %{buildroot}%{_sysconfdir}/
mv %{buildroot}/usr/etc/* %{buildroot}%{_sysconfdir}/

%check
%{__python2} setup.py test

%files
%doc README.rst
%license LICENSE
%exclude %{python2_sitelib}/sahara_tests/scenario
%exclude %{python2_sitelib}/sahara_tests/unit/scenario
%{python2_sitelib}/sahara_tests
%{python2_sitelib}/sahara_tests-*.egg-info
# moving sahara-scenario and sahara_tempest_plugin
# to python-sahara-tests-tempest and python-sahara-tests-scenario
%exclude %{_bindir}/sahara-scenario
%exclude %{python2_sitelib}/sahara_tempest_plugin
%exclude %{_sysconfdir}/sahara-scenario/*

%files -n python-%{service}-tempest
%license LICENSE
%{python2_sitelib}/sahara_tempest_plugin

%files -n python-%{service}-scenario
%license LICENSE
# FIXME /sahara_tests/scenario/defaults contains jar file
# We are need to find a way to build the jar files properly
# https://trello.com/c/jDJnTO22/305-sahara-tests-jar-unbundling-tracker
%{python2_sitelib}/sahara_tests/scenario
%{python2_sitelib}/sahara_tests/unit/scenario
%{_bindir}/sahara-scenario
%config(noreplace) %{_sysconfdir}/sahara-scenario/*


%if 0%{?with_doc}
%files doc
%license LICENSE
%doc doc/build/html
%endif

%changelog
* Wed Mar 15 2017 Jon Schlueter <jschluet@redhat.com> 0.4.1-1
- Update to 0.4.1 (rhbz#1432524)

* Mon Feb 13 2017 Jon Schlueter <jschluet@redhat.com> 0.4.0-1
- Update to 0.4.0 (rhbz#1421838)

* Thu Jan 12 2017 Jon Schlueter <jschluet@redhat.com> 0.3.0-10
- Adding missing data sources API tests
- Add CDH 5.9.0 scenario test
- [doc] Added doc for Sahara Tempest plugin
- Add test to node group template editing
- Clean env before and after tempest test
- [doc] Update Authentication section in Scenario Readme
- Fix typos in cover.sh
- Added cli tests for job binary
- Add new negative cli tests for image and job binary
- Added cli-test for "plugin update"
- More timetracking: start of tasks, exceptions
- [doc] Updated doc for Sahara scenario tests
- Exclude ct and cluster names from scenarios
- Renaming of all images names for one pattern (lp#1645695)

* Mon Nov 28 2016 Jon Schlueter <jschluet@redhat.com> 0.3.0-9
- Show team and repo badges on README
- Remove more usages of Tempest core code
- scenario job improvements
- Less deps on private Tempest APIs (utils, exceptions)

* Mon Nov 21 2016 Jason Joyce <jjoyce@redhat.com> 0.3.0-8
- [Trivial]Replace the combination symbol in file name

* Thu Nov 17 2016 Jon Schlueter <jschluet@redhat.com> 0.3.0-7
- Added test for job update using cli

* Thu Nov 10 2016 Jon Schlueter <jschluet@redhat.com> 0.3.0-6
- Fix CLI configs get test for plugins with more versions
- Get plugin data: dynamically discover the output file
- Add default values for the flavors in MapR templates
- If the name of custom flavor exists, use it

* Tue Nov 08 2016 Jon Schlueter <jschluet@redhat.com> 0.3.0-5
- Revert "Temp workaround: drop volumes from tests"
- Added cli-tests with "job" command

* Tue Nov 01 2016 Jon Schlueter <jschluet@redhat.com> 0.3.0-4
- Move flavor_id to page args

* Fri Oct 28 2016 Jon Schlueter <jschluet@redhat.com> 0.3.0-3
- Temp workaround: drop volumes from tests

* Thu Oct 20 2016 Jon Schlueter <jschluet@redhat.com> 0.3.0-2
- Fix sahara gate: failure in tempest config options access
- Enable release notes translation

* Wed Oct 05 2016 Elise Gafford <egafford@redhat.com> 0.3.0-1
- Import of RDO version 0.3.0-1 into RHOS
- Resolves: rhbz#1368048
- Update to 0.3.0

* Thu Sep 22 2016 Alfredo Moralejo <amoralej@redhat.com> 0.2.1-0.1.81a18a75git
- Update to post 0.2.0 (81a18a7532457b7ae2d6322f9ca84a62eca7da79)
